""" calculate the Fibonacci numbers using an iterator class """
import itertools

class FibonacciNumbers:
    a, b = 0, 1
    def __iter__(self):
        return self

    def __next__(self):
        ret = self.a
        self.a, self.b = self.b, self.a + self.b
        return ret

if __name__ == '__main__':
    fib = FibonacciNumbers()

    # consumer: list from iterator slice
    print(list(itertools.islice(fib, 8)))

    # consumer: for loop over iterator slice
    for numb in itertools.islice(fib, 8):
        print(numb)
